︠41ac1da5-62ff-4661-8337-bb1614a44e7d︠
var('u,v,r,R,p,q')

rho(r,R) = (R-r)/2.0
phi(u,r,R) = (r + rho(r,R)) + rho(r,R)*cos(u)
psi(u,r,R) = rho(r,R)*sin(u)

T(u,v,r,R) = [phi(u,r,R)*cos(v), phi(u,r,R)*sin(v), psi(u,r,R)]

generalKnot(r,R,p,q,t) = [phi(2*pi*q*t,r,R)*cos(2*pi*p*t), phi(2*pi*q*t,r,R)*sin(2*pi*p*t), psi(2*pi*q*t,r,R)]
︡9dc8b33e-cf9f-4fc9-a515-e3af41631344︡︡
︠280e4e7c-6e3f-4365-8584-503d69690546︠
@interact
def plotKnot(s1=slider(1,29,step_size=1,default=2, label="p"), s2=slider(1,29,step_size=1, default=3, label="q"),opac=slider(0.1,1,step_size=0.05,default=0.85,label="Torus Opacity"),chkBox=("Show Torus",False),frame=("Show Frame",False)):
    	p1 = parametric_plot3d(T(r=1,R=2), (u,0,2*pi), (v,0,2*pi),opacity=opac, color='yellow',aspect_ratio=1,frame=False)
	p2 = parametric_plot3d(generalKnot(r=1,R=2, p=s1,q=s2), (t,0,1), thickness=6, color='purple',frame=frame,aspect_ratio=1)
	if chkBox == True:
            (p1+p2).show()
        else:
                p2.show()
︡953a1c38-9573-4a36-a201-9aad71f6cfb2︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-2\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table>\n<tr><td colspan=3><table><tr><td align=right><font color=\"black\">p&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-s1-2\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-s1-2-lbl\"></font></td></tr></table><script>(function(){ var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\",\"21\",\"22\",\"23\",\"24\",\"25\",\"26\",\"27\",\"28\",\"29\"]; setTimeout(function() {\n    $('#slider-s1-2').slider({\n        step: 1, min: 0, max: 28, value: 1,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-s1-2-lbl').text(values[position]); interact(2, '_interact_.update(\\'2\\', \\'s1\\', 58, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'2\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-s1-2-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-s1-2-lbl').text(values[$('#slider-s1-2').slider('value')]);\n    }, 1); })();</script></td>\n</tr><tr><td align=right><font color=\"black\">q&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-s2-2\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-s2-2-lbl\"></font></td></tr></table><script>(function(){ var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\",\"21\",\"22\",\"23\",\"24\",\"25\",\"26\",\"27\",\"28\",\"29\"]; setTimeout(function() {\n    $('#slider-s2-2').slider({\n        step: 1, min: 0, max: 28, value: 2,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-s2-2-lbl').text(values[position]); interact(2, '_interact_.update(\\'2\\', \\'s2\\', 59, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'2\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-s2-2-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-s2-2-lbl').text(values[$('#slider-s2-2').slider('value')]);\n    }, 1); })();</script></td>\n</tr><tr><td align=right><font color=\"black\">Torus Opacity&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-opac-2\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-opac-2-lbl\"></font></td></tr></table><script>(function(){ var values = [\"0.100000000000000\",\"0.150000000000000\",\"0.200000000000000\",\"0.250000000000000\",\"0.300000000000000\",\"0.350000000000000\",\"0.400000000000000\",\"0.450000000000000\",\"0.500000000000000\",\"0.550000000000000\",\"0.600000000000000\",\"0.650000000000000\",\"0.700000000000000\",\"0.750000000000000\",\"0.800000000000000\",\"0.850000000000000\",\"0.900000000000000\",\"0.950000000000000\",\"1.00000000000000\"]; setTimeout(function() {\n    $('#slider-opac-2').slider({\n        step: 1, min: 0, max: 18, value: 15,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-opac-2-lbl').text(values[position]); interact(2, '_interact_.update(\\'2\\', \\'opac\\', 60, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'2\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-opac-2-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-opac-2-lbl').text(values[$('#slider-opac-2').slider('value')]);\n    }, 1); })();</script></td>\n</tr><tr><td align=right><font color=\"black\">Show Torus&nbsp;</font></td><td><input type=\"checkbox\"  width=200px onchange=\"interact(2, '_interact_.update(\\'2\\', \\'chkBox\\', 61, _interact_.standard_b64decode(\\''+encode64(this.checked)+'\\'), globals()); _interact_.recompute(\\'2\\');')\"></input></td>\n</tr><tr><td align=right><font color=\"black\">Show Frame&nbsp;</font></td><td><input type=\"checkbox\"  width=200px onchange=\"interact(2, '_interact_.update(\\'2\\', \\'frame\\', 62, _interact_.standard_b64decode(\\''+encode64(this.checked)+'\\'), globals()); _interact_.recompute(\\'2\\');')\"></input></td>\n</tr></table></td></tr>\n<tr><td></td><td style='width: 100%;'><div id=\"cell-interact-2\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td><td></td></tr>\n<tr><td colspan=3></td></tr>\n</table></td>\n                 </tr></table></div>\n                 "}︡
